function [v,YY]=ajuste_impedancia_2(f,Y,n)
[m1,imax]=max(imag(Y)./f);
[m2,imin]=min(imag(Y)./f);
fn=f(imax);
fp=f(imin);
fr=sqrt((fp^2+fn^2)/2);
Q=2*fr^2/(fp^2-fn^2);
 
% R0=max(real(1./Y));
C0=imag(Y(1))/(2*pi*f(1));
R1=1/(max(real(Y)));
C1=1/(Q*R1*2*pi*fr);
L1=Q*R1/(2*pi*fr);

x=[1*C0 1*R1 1*L1 1*C1 ];
 
global scale
O_C0=floor(log10(C0));
O_R1=floor(log10(R1));
O_L1=floor(log10(L1));
O_C1=floor(log10(C1));

scale=10.^-[O_C0 O_R1 O_L1 O_C1 ];
 
options=optimset(...
                 'TolFun',0,'TolX',0,...
                 'MaxFunEvals',200000,'MaxIter',n,...
                 'Display','off');
[xx,RESNORM,RESIDUAL,EXITFLAG,OUTPUT]=lsqcurvefit(@admitancia_piezo2,x.*scale,f,[real(Y); imag(Y)],[],[],options);

YY=admitancia_piezo2(xx,f);
YY=YY(1,:)+1i.*YY(2,:);
xx=xx./scale;
 
fr=1/2/pi/sqrt(xx(3)*xx(4));
Q=sqrt(xx(3)/xx(4))/xx(2);
Af=fr/Q;
 
disp(['Q = ' num2str(Q)]);
disp(['fr = ' num2str(fr) ' Hz']);
disp(['Rm = ' num2str(xx(2)) ' ohm']);
disp(['Lm = ' num2str(xx(3)*1e3) ' mH']);
disp(['Cm = ' num2str(xx(4)*1e15) ' fF']);
 
v=[xx Q fr];
 
end
 

